//
//    EMAIL: castlewrks@aol.com
//    NAME: Robert J Becraft
//    TOPIC:  Gardens

//------------------------------------------------------ ROOF101 Textures
    #declare P_Roof101A = pigment { 
      bozo
      pigment_map {
        [0.00 colour Gray10]
        [0.20 colour GreenCopper]
        [0.80 colour Gray50]
        [1.00 colour Gray60]  
//        [0.00 colour DarkGreenCopper]
//        [0.20 colour SeaGreen2]
//        [0.80 colour SeaGreen1]
//        [1.00 colour SeaGreen3]        
      }
      scale 5
    }
 
    #declare P_Roof101B = pigment {P_Roof101A  warp { repeat x*8 offset <0,45,0> } }
    #declare P_Roof101C = pigment {P_Roof101B  warp { repeat y*3 offset <60,0,0> } }

    #declare T_Roof101 = texture {
      pigment { P_Roof101C }   //turbulence 0.075 }
      normal { granite 0.2 }
    }
#declare RoofText101=texture{T_Roof101 scale .05}
            
//---- From mainpart.inc             
#declare Window1a=union{
      box{<-.1,.5,-.55><.1,2.05,-.5> texture{pigment{color White}}}
      box{<-.1,.5,.55><.1,2.05,.5> texture{pigment{color White}}}

      box{<-.1,2.,-.55><.1,2.05,.55> texture{pigment{color White}}}
      box{<-.1,.45,-.55><.1,.5,.55> texture{pigment{color White}}}

      box{<-.061,.5,-.025><.061,2,.025> texture{pigment{color White}}}    // center verticle
      box{<-.081,1.22,-.5><.081,1.27,.5> texture{pigment{color White}}} // center horizontal

      box{<-.01,.5,-.5><.01,2,.5> texture{pigment{color Black}}
         finish  { F_Glass2 }
         }   // glass
}

#declare Window1=union{
      object{Window1a}
      
      box{<-.051,0.5,-.265><.051,2,-.225> texture{pigment{color White}}}    // left verticle
      box{<-.051,0.5,.265><.051,2,.225> texture{pigment{color White}}}    // right verticle

      box{<-.051,1.6175,-.5><.051,1.6575,.5> texture{pigment{color White}}} // top horizontal
      box{<-.051,0.8425,-.5><.051,0.8825,.5> texture{pigment{color White}}} // bottom horizontal      
      rotate<0,90,0>
}      
//-----------  

#declare Dormer=union{
    box{<-.75,0,-1.5><.75,3,3.5> texture{T_GrayBrick scale .0325}}
    union{
       triangle{<-.75,3,-1.5> <0,5,-1>      <.75,3,-1.5>}
       triangle{<-.75,3,-1.5> <-.75,3,3.5> <0,5,-1>}
       triangle{<-.75,3,3.5>  <0,5,-1>      <0,5,3.5>}
       triangle{<.75,3,-1.5>  <.75,3,3.5>  <0,5,-1>}
       triangle{<.75,3,3.5>   <0,5,-1>      <0,5,3.5>}       
      texture{RoofText101}
    } // union
    object{Window1 translate<0,.5,-1.5>}
} // dormer
      
#declare MainWing=union{
      box{<-10,0,-30><10,12,30>}         
      
      union{
        #declare C1=1;
        #while (C1<12)
          box{<-10.1,C1,-30.1><-9,C1+.5,-29>}
          box{<10.1,C1,-30.1><9,C1+.5,-29>}
          #declare C1=C1+1;
        #end 
       texture{T_Stone8}
      }
      
      box{<-10.05,11.9,-30.05><10.05,12,30.05> texture{T_Stone8}} 
      box{<-10.05,0,-30.05><10.05,4,30.05> texture{T_TanBrick scale .065}}       

      union{                                                                                            
        triangle{<-10,12,-30><10,12,-30><0,28,-25>}
        triangle{<-10,12,30><10,12,30><0,28,25>}
        triangle{<-10,12,-30><-10,12,30><0,28,-25>}
        triangle{<-10,12,30><0,28,-25><0,28,25>}       
        triangle{<10,12,-30><10,12,30><0,28,-25>}
        triangle{<10,12,30><0,28,-25><0,28,25>}        
       texture{RoofText101 }
      }// union 
             
      #declare C1=-8;
      #while (C1<=8.5)             
         object{Window1 translate<C1,9,-30>}
         object{Window1 translate<C1,5.5,-30>}
         object{Window1 translate<C1,1,-30.05>}
//         object{Dormer translate<C1,12.25,-28.25>}         
         #declare C1=C1+2;
      #end

      #declare C1=-6;
      #while (C1<=6.5)             
         object{Dormer translate<C1,12.25,-28.25>}         
         #declare C1=C1+2;
      #end
    
//      object{Dormer translate<-4.5,12.25,-28.25>}
//      object{Dormer translate<-1.5,12.25,-28.25>}
//      object{Dormer translate<4.5,12.25,-28.25>}
//      object{Dormer translate<1.5,12.25,-28.25>}
            
      object{Dormer translate<-1.5,18,-26.5>}
      object{Dormer translate<1.5,18,-26.5>}
      
}  // MainWing      
      
#declare Main=union{
      box{<-25,0,-20><25,12,20>}
      box{<-25.05,11.9,-20.05><25.05,12,20.05> texture{T_Stone8}}
      box{<-25.05,0,-20.05><25.05,4,20.05> texture{T_TanBrick scale .065}}
     
      union{
        triangle{<-35,12,-20><35,12,-20><35,28,0>}
        triangle{<-35,12,-20><35,28,0><-35,28,0>}
       texture{RoofText101}
      } // union                             
      
      object{MainWing translate<-35,0,0>}
      object{MainWing translate<35,0,0>}
      
      box{<-10,0,-25><10,12,25>}
      box{<-10.05,11.9,-25.05><10.05,12,25.05> texture{T_Stone8}}
      box{<-10.05,0,-25.05><10.05,4,25.05> texture{T_TanBrick scale .065}}    

      #declare C1=-8.5;
      #while (C1<=-2.5)             
         object{Window1 translate<C1,9,-25>}
         object{Window1 translate<C1,5.5,-25>}
         object{Window1 translate<C1,1,-25.05>}
         #if (C1>-5)
           object{Dormer translate<C1,12.5,-22.75>}
         #end
         #declare C1=C1+2;
      #end
      
      union{
        triangle{<-10,10,-25><10,10,-25><0,26,-20>}
        triangle{<-10,10,25><10,10,25><0,26,20>}
        triangle{<-10,10,-25><-10,10,25><0,26,-20>}
        triangle{<-10,10,25><0,26,-20><0,26,20>}       
        triangle{<10,10,-25><10,10,25><0,26,-20>}
        triangle{<10,10,25><0,26,-20><0,26,20>}        
       texture{RoofText101 }
      }// union         
      
      difference{
        union{
         box{<-1,0,-30><9,18,-20>}    // main tower 
         box{<-1.05,17.9,-30.05><9.05,18,-19.05> texture{T_Stone8}}
         box{<-1.05,0,-30.05><9.05,7,-19.05> texture{T_TanBrick scale .065}}
        } // union
        box{<-1.1,0,-29><9.1,4,-27>}
        cylinder{<-1.1,4,-28><9.1,4,-28> 1}
        box{<0,0,-30.1><2,4,-26.5>}
        cylinder{<1,4,-30.1><1,4,26.5> 1} 
        box{<3,0,-30.1><5,4,-26.5>}
        cylinder{<4,4,-30.1><4,4,26.5> 1} 
        box{<6,0,-30.1><8,4,-26.5>}
        cylinder{<7,4,-30.1><7,4,26.5> 1}         
       } // difference 

      #declare C1=1;
      #while (C1<=7.5)             
         object{Window1 translate<C1,10.5,-30>}
         object{Window1 translate<C1,7,-30>}
         object{Window1 translate<C1,14.5,-30>}
         #declare C1=C1+2;
      #end
      
      // Front Stairs
         box{<-1.05,1,-30.05><9.05,1.25,-19.05> texture{T_Stone5}}
         box{<-1.55,.75,-30.55><9.55,1,-18.65> texture{T_Stone5}}                   
         box{<-2.05,.5,-31.05><10.05,.75,-18.05> texture{T_Stone5}}           
         box{<-2.55,.25,-31.55><10.55,.5,-17.65> texture{T_Stone5}}           
         box{<-3.05,0,-32.05><11.05,.25,-17.05> texture{T_Stone5}}           
         object{Window1 translate<2,9,-20>}
         object{Window1 translate<4,5.5,-20>}
         object{Window1 translate<7,1,-20.05>}          
      
      union{
        triangle{<-5,18,-5><5,18,-5><0,30,0>}
        triangle{<-5,18,-5><-5,18,5><0,30,0>}
        triangle{<5,18,-5><5,18,5><0,30,0>}
        triangle{<-5,18,5><5,18,5><0,30,0>}                        
        translate<4,0,-25>
       texture{RoofText101}
      }// union
      
      #declare C1=-23.5;
      #while (C1<=-11.5)             
         object{Window1 translate<C1,9,-20>}
         object{Window1 translate<C1,5.5,-20>}
         object{Window1 translate<C1,1,-20.05>}   
         object{Window1 translate<-C1,9,-20>}
         object{Window1 translate<-C1,5.5,-20>}
         object{Window1 translate<-C1,1,-20.05>} 
         object{Dormer translate<C1,12.5,-18>}
         object{Dormer translate<C1,18,-11>}
         object{Dormer translate<-C1,12.5,-18>}
         object{Dormer translate<-C1,18,-11>}
         #declare C1=C1+2;
      #end

         object{Dormer translate<-9.5,18,-11>}
         object{Dormer translate<-7.5,18,-11>}
         object{Dormer translate<-5.5,18,-11>}   
         object{Dormer translate<9.5,18,-11>}
         object{Dormer translate<7.5,18,-11>}
         object{Dormer translate<5.5,18,-11>}                         
      
      union{   
        #declare C1=1;
        #while (C1<12)
           box{<-10.1,C1,-25.1><-9,C1+.5,-24> }
           box{<10.1,C1,-25.1><9,C1+.5,-24> } 
           #declare C1=C1+1;
        #end                           
        #declare C1=1;
        #while (C1<18)
           box{<-1.1,C1,-30.1><0,C1+.5,-29> }
           box{<9.1,C1,-30.1><8,C1+.5,-29> } 
           #declare C1=C1+1;
        #end        
        texture{T_Stone8}
      }
           
      
      texture{T_GrayBrick scale .0325}
} // Main
      
      
